#include <stdio.h>

// My useful function is a helper to print out art pieces made in 2D arrays. This is just meant to simplify the whole "scale and print" process.
// We basically just print out each line and character "multiplied" by the scale by using a for loop to keep printing the same lines and characters.
void scaleAndPrintArt(int xSize, int ySize, int scale, char art[][xSize]) {
  for (int y = 1; y <= ySize; y++) {
    for (int yScale = 1; yScale <= scale; yScale++) {
      for (int x = 1; x <= xSize; x++) {
        for (int xScale = 1; xScale <= scale; xScale++) {
          printf("%c", art[y-1][x-1]);
        }
      }
      printf("\n");
    }
  }
}

int main() {
  // Art Piece: "Moonlit Solutude" -by OpenAI's ChatGPT
  // The art piece is simply me asking chatgpt to come up with a 5x5 ascii art.
  // "The arrangement attempts to capture a serene night scene with a tree under the moonlight."
  // | trunk, * leaves, o moon, - ground
  char art[5][5] = {{'o',' ',' ',' ','\\'},{' ','*','|','*',' '},{' ',' ','|',' ',' '},{' ','*','*','*',' '},{'-','-','-','-','-'}};
  // Print the base image before anything else.
  scaleAndPrintArt(5, 5, 1, art);
  printf("\n");
  int scale = 0;
  // Prompt user for scale factor. Keep trying until scale > 0.
  while (scale <= 0) {
    printf("Enter a positive scale factor: ");
    scanf("%d", &scale);
  }
  printf("\n");
  scaleAndPrintArt(5, 5, scale, art);
  return 0;
}
